Bug 52275

Summary: memory leak in proxy_ajp_handler
Product: Apache httpd-2 Reporter: Naohiro Ooiwa <naohiro.ooiwa>
Component: mod_proxy_ajpAssignee: Apache HTTPD Bugs Mailing List <bugs>
Status: RESOLVED LATER    
Severity: normal Keywords: FixedInTrunk
Priority: P2    
Version: 2.3.15-beta   
Target Milestone: ---   
Hardware: All   
OS: Linux   
Attachments: remove-potential-for-memory-leak-in-mod_proxy_ajp.patch

Description Naohiro Ooiwa 2011-12-02 04:31:15 UTC
Created attachment 28017 [details]
remove-potential-for-memory-leak-in-mod_proxy_ajp.patch

Hello,

I use mod_proxy_ajp with keepalive connection.

When the client continued to request to the connection,
RSS of httpd has increased by 16 Kbytes per minute.

I found a memory leak in proxy_ajp_handler.
And I found r707163 in trunk too.

I attach a patch what I made based on r707163.
I confirmed that the memory leak is fixed by this patch.
Therefore, we should merge this fix to proxy_ajp_handler.

Please check my patch.

Regards,
Naohiro Ooiwa
Comment 1 Naohiro Ooiwa 2012-03-28 04:29:13 UTC
Hi all

I tried to request stress test on the one session to the apache.
The memory leak of about 600 Kbytes per second had occurred.

And I tried to use mod_jk instead of mod_proxy_ajp.
In this case, the memory leak didn't happen.

Regards,
Naohiro Ooiwa
Comment 2 Stefan Fritsch 2012-05-05 08:31:46 UTC
fixed in trunk r1334343
Comment 3 Rainer Jung 2012-08-21 16:03:31 UTC
Ported back to 2.4 as r1368450.
Released with 2.4.3.
Should probably be ported back to 2.2 as well.